#  FC5:  dbase, readline, recode, mcrypt, mhash, tidy, mssql

%define def()	%%{!?_without_default:%%{!?_without_%1: %%global _with_%1 --with-%1}}

%{expand:%def dbase}
%{expand:%def readline}
#  recode
%{expand:%def mcrypt}
%{expand:%def mhash}
%{expand:%def tidy}
#  mssql
%{expand:%def mssql}

%define list	%{?_with_dbase:dbase} %{?_with_readline:readline} %{?_with_recode:recode} %{?_with_mcrypt:mcrypt} %{?_with_mhash:mhash} %{?_with_tidy:tidy} %{?_with_mssql:mssql}


%global extdir	%(php-config --extension-dir 2>/dev/null || echo "undefined")
%global apiver	%((echo 0; php -i 2>/dev/null | sed -n 's/^PHP API => //p') | tail -1)


Name: php-extras
Summary: Additional PHP modules from the standard PHP distribution
#Version: %(php-config --version 2>/dev/null || echo 0)
Version: 5.1.6
Release: 15%{?dist}.1
Group: Development/Languages
License: The PHP License
URL: http://www.php.net/
Source0: http://www.php.net/distributions/php-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: php-devel = %{version}

#php-extras patches
Patch0:  php-extras-5.1.2-readline.patch
Patch10: php-extras-5.1.6-mssql.patch

#php patches
Patch1: php-5.1.4-gnusrc.patch
Patch2: php-5.1.4-warnings.patch
Patch5: php-4.3.3-install.patch
Patch6: php-5.0.4-norpath.patch
Patch7: php-4.3.2-libtool15.patch
Patch13: php-5.0.2-phpize64.patch
Patch14: php-5.1.6-ecalloc.patch

# Fixes for extension modules
Patch21: php-4.3.1-odbc.patch
Patch22: php-4.3.11-shutdown.patch

# Functional changes
Patch30: php-5.0.4-dlopen.patch
Patch31: php-5.0.0-easter.patch

# Fixes for tests
Patch50: php-5.0.4-tests-dashn.patch
Patch51: php-5.0.4-tests-wddx.patch

# Security fixes
Patch70: php-4.3.9-CVE-2006-5465.patch
Patch71: php-5.1.6-CVE-2007-0906-imap.patch
Patch72: php-4.3.9-CVE-2007-0906-strreplace.patch
Patch73: php-4.3.9-CVE-2007-0907.patch
Patch74: php-4.3.9-CVE-2007-0908.patch
Patch75: php-4.3.9-CVE-2007-0909-odbc.patch
Patch76: php-4.3.9-CVE-2007-0909-printf.patch
Patch77: php-5.1.6-CVE-2007-0910.patch
Patch78: php-4.3.9-CVE-2007-0988.patch
Patch79: php-5.1.6-CVE-2007-1285.patch
Patch80: php-5.1.6-CVE-2007-1583.patch
Patch81: php-5.1.6-CVE-2007-0455.patch
Patch82: php-5.1.6-CVE-2007-1001.patch
Patch83: php-5.1.6-CVE-2007-1718.patch
Patch84: php-5.1.6-CVE-2007-1864.patch
Patch85: php-5.1.6-soapredir.patch
Patch86: php-5.1.6-ftpcrlf.patch
Patch87: php-5.1.6-CVE-2007-2872.patch
Patch88: php-5.1.6-CVE-2007-4658.patch
Patch89: php-5.1.6-CVE-2007-2756.patch
Patch90: php-5.1.6-CVE-2007-3799.patch
Patch91: php-5.1.6-CVE-2007-3996.patch
Patch92: php-5.1.6-CVE-2007-4670.patch
Patch93: php-5.1.6-CVE-2007-3998.patch


%description
PHP is an HTML-embedded scripting language.

This package contains various additional modules for PHP, which
have not been included in the basic PHP package for Fedora Core.


%package -n php-dbase
Summary: Standard dBase module for PHP applications
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}

%description -n php-dbase
Standard dBase module for PHP applications


%package -n php-readline
Summary: Standard PHP module provides readline library support
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}
%{?_with_readline:BuildRequires: readline-devel}

%description -n php-readline
Standard PHP module provides readline library support


%package -n php-recode
Summary: Standard PHP module provides GNU recode support
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}
%{?_with_recode:BuildRequires: recode-devel}

%description -n php-recode
Standard PHP module provides GNU recode support


%package -n php-mcrypt
Summary: Standard PHP module provides mcrypt library support
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}
%{?_with_mcrypt:BuildRequires: libmcrypt-devel}

%description -n php-mcrypt
Standard PHP module provides mcrypt library support


%package -n php-mhash
Summary: Standard PHP module provides mhash support
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}
%{?_with_mhash:BuildRequires: mhash-devel}

%description -n php-mhash
Standard PHP module provides mhash support


%package -n php-tidy
Summary: Standard PHP module provides tidy library support
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}
%{?_with_tidy:BuildRequires: libtidy-devel}

%description -n php-tidy
Standard PHP module provides tidy library support


%package -n php-mssql
Summary: Standard PHP module provides mssql support
Group: Development/Languages
Requires: php >= %{version}, php-api = %{apiver}
%{?_with_mssql:BuildRequires: freetds-devel}

%description -n php-mssql
Standard PHP module provides mssql support



%prep
%setup -q -n php-%{version}
%patch0 -p1
%patch10 -p1

%patch1 -p1 -b .gnusrc
%patch2 -p1 -b .warnings
%patch5 -p1 -b .install
%patch6 -p1 -b .norpath
%patch7 -p1 -b .libtool15
%patch13 -p1 -b .phpize64
%patch14 -p1 -b .ecalloc

%patch21 -p1 -b .odbc
%patch22 -p1 -b .shutdown

%patch30 -p1 -b .dlopen
%patch31 -p1 -b .easter

%patch50 -p1 -b .tests-dashn
%patch51 -p1 -b .tests-wddx

%patch70 -p1 -b .cve5465
%patch71 -p1 -b .cve0906-imap
%patch72 -p1 -b .cve0906-strreplace
%patch73 -p1 -b .cve0907
%patch74 -p1 -b .cve0908
%patch75 -p1 -b .cve0909-odbc
%patch76 -p1 -b .cve0909-printf
%patch77 -p1 -b .cve0910
%patch78 -p1 -b .cve0988
%patch79 -p1 -b .cve1285
%patch80 -p1 -b .cve1583
%patch81 -p1 -b .cve0455
%patch82 -p1 -b .cve1001
%patch83 -p1 -b .cve1718
%patch84 -p1 -b .cve1864
%patch85 -p1 -b .soapredir
%patch86 -p1 -b .ftpcrlf
%patch87 -p1 -b .cve2872
%patch88 -p1 -b .cve4658
%patch89 -p1 -b .cve2756
%patch90 -p1 -b .cve3799
%patch91 -p1 -b .cve3996
%patch92 -p1 -b .cve4670
%patch93 -p1 -b .cve3998


%build

export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"


for mod in %{list}
do
    pushd ext/$mod

    phpize
    %configure --with-libdir=%{_lib}

    # cause libtool to avoid passing -rpath when linking
    # (this hack is well-known as "libtool rpath workaround")
    sed -i 's|^hardcode_libdir_flag_spec|hardcode_libdir_flag_spec=" -D__LIBTOOL_IS_A_FOOL__ "|' libtool

    make %{?_smp_mflags}

    popd
done


%check

#
# As we don't build whole php here, we must do all the tests
# with the system php executable. Unfortunately, we cannot use
# system's /usr/bin/php directly, therefore a wrapper is needed.
# 
# Some reasons for such a wrapper are:
# - /usr/bin/php cannot handle "-d extension=" etc. on the command line
#   (probably because of the CGI-oriented variant of php executable is
#   installed as /usr/bin/php). We should use own config file for this.
# - During "run-tests.php" execution, php is invoked again (recursively).
#   (i.e. we cannot explicitly set another config for deeper php invokation).
# - We cannot exclude /etc/php.d/* files on the host machine. It can lead to
#   some stderr reports, which spoil the tests' output. To omit extra warnings,
#   the stderr is redirected to /dev/null
# - When invoked again, some CGI-related environment variables are set 
#   by default, which confuse php a lot. Therefore the environment is cleared,
#   and only needed variables are provided.
# 
# The test stuff is derived from the original tests in the php tarball,
# with preserving some needed specifications etc.
#
  

mkdir modules || exit 1

cat >modules.ini <<EOF
open_basedir=
safe_mode=0
output_buffering=0
extension_dir=$PWD/modules
EOF

for mod in %{list}
do
    cp -a ext/$mod/modules/${mod}.so modules
    echo "extension=${mod}.so" >>modules.ini
done

cat >php <<EOF
#!/bin/sh
exec 2>/dev/null
env -i TEST_PHP_EXECUTABLE=$PWD/php TEST_PHP_SRCDIR=\$TEST_PHP_SRCDIR \
	NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2 \
	%{_bindir}/php -c $PWD/modules.ini "\$@"
EOF
chmod +x ./php


for mod in %{list}
do
    [ -d ext/$mod/tests ] || continue

    pushd ext/$mod

    TEST_PHP_SRCDIR=$PWD ../../php ../../run-tests.php tests

    set +x
    fail=0
    for f in tests/*.diff
    do
	[ -f "$f" ] || continue
	echo "TEST FAILURE: $PWD/$f --"
	cat $f
	echo
	echo "-- $PWD/$f result ends."
	fail=1
    done
    [ $fail -ne 0 ] && exit $fail
    
    popd
done


%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{extdir}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/php.d

for mod in %{list}
do
    install -m755 ext/${mod}/modules/*.so $RPM_BUILD_ROOT%{extdir}

    cat > $RPM_BUILD_ROOT%{_sysconfdir}/php.d/${mod}.ini <<EOF
; Enable ${mod} extension module
extension=${mod}.so
EOF
    cat > files.${mod} <<EOF
%defattr(-,root,root)
%{extdir}/${mod}.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php.d/${mod}.ini
EOF
done


%clean
rm -rf $RPM_BUILD_ROOT


#%%files
%define fil()	%%{?_with_%1:%%files -n php-%1 -f files.%1}
%{expand:%fil dbase}
%{expand:%fil readline}
%{expand:%fil recode}
%{expand:%fil mcrypt}
%{expand:%fil mhash}
%{expand:%fil tidy}
%{expand:%fil mssql}



%changelog
* Thu Mar 27 2008 Johnny Hughes <johnny@centos.org> 5.1.6-15
- rolled in security updates
- added freetds build requirement and php-mssql
- added --with-libdir=%%{_lib} to handle 64bit arches properly
- add patch for mssql (rh bug #244736), a backport of some php-5.2 changes

* Sat Jul 21 2007 Johnny Hughes <johnny@centos.org> 5.1.6-12
- rolled in php security updates from CentOS-5

* Mon Nov 27 2006 Jim Perrin <jperrin@centos.org>
- Changed CFLAGS to build properly

* Mon Oct 23 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.6-1
- update to 5.1.6

* Thu Jun 22 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.4-2
- auto-detect extdir and apiver again (needed for x86_64)

* Fri Jun 16 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.4-1
- update to upstream php 5.1.4
- an easier way to auto-detect php-api version
- specify extdir and apiver explicitly, because FE build system
  is not able to auto-detect it now.

* Fri Mar 31 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.2-3
- ppc arch hack: change dir before %%apiver auto-detecting

* Sat Mar 25 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.2-2
- Accepted for Fedora Extras
  (review by Tom "spot" Callaway <tcallawa@redhat.com>)
 
* Wed Mar  1 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.2-2
- more accurate Requires for the main php
  (using php-api, provided now by the Core php package).

* Tue Feb 28 2006 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.2-1
- update to 5.1.2
- replace readline patch (old issue go away and a new appears).
- apply well-known "libtool-rpath-workaround" (see in Internet ;-))
  to avoid use -rpath for linking

* Sat Dec 17 2005 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.1.1-1
- upgrade to 5.1.1 for FC5
- drop now missed "fam" and obsolete "sqlite" (sqlite2) modules

* Mon Nov 14 2005 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.0.4-1
- spec file cleanups

* Mon Oct 10 2005 Dmitry Butskoy <Dmitry@Butskoy.name> - 5.0.4-0
- adaptation for php5
- drop tests patch (no more needed).

* Fri Oct  7 2005 Dmitry Butskoy <Dmitry@Butskoy.name> - 4.3.11-0
- initial release
- create test stuff for check section. A lot of work because we play
  with extra modules by our own way...
- add patch to fix some pathes in tests
- add patch for readline configure

